include_recipe "mdadm"

execute "swapoff" do
	command "swapoff -a"
end

execute "copy partitions" do
	command "sgdisk -R /dev/sda /dev/sdb && sgdisk -G /dev/sda"
end
case node["platform"]
	when 'redhat', 'centos', 'amazon', 'scientific', 'oracle'
		if node["platform_version"] >= "7" 
			execute "remake grub2 config" do
				command "grub2-mkconfig -o /boot/grub2/grub.cfg"
			end
			execute "add sda2 to md0" do
				command 'mdadm --add /dev/md0 /dev/sda2'
			end
			execute "install boot after sync /boot.." do
				command "for((f=1;f>0;))do grep -q idle /sys/block/md0/md/sync_action ; f=$?; sleep 1;done && grub2-install /dev/sda"
			end
			execute "add sda3 to md1" do
				command 'mdadm --add /dev/md1 /dev/sda3'
			end
			execute "add sda5 to md2" do
				command 'mdadm --add /dev/md2 /dev/sda5'
			end
			raid_part "/dev/sda4" do
				action :mkswap
			end
		else
			execute "add sda2 to md0" do
				command 'mdadm --add /dev/md0 /dev/sda1'
			end
			execute "install boot after sync /boot.." do
				command 'for((f=1;f>0;))do grep -q idle /sys/block/md0/md/sync_action ; f=$?; sleep 1;done && echo -e "device (hd0) /dev/sda \n root (hd0,0) \n setup (hd0)" | grub'
			end
			execute "add sda3 to md1" do
				command 'mdadm --add /dev/md1 /dev/sda2'
			end
			execute "add sda5 to md2" do
				command 'mdadm --add /dev/md2 /dev/sda4'
			end
			raid_part "/dev/sda3" do
				action :mkswap
			end			
		end

	when 'debian', 'ubuntu'
		execute "remake grub config" do
				command "grub-mkconfig -o /boot/grub/grub.cfg"
		end
		execute "add sda2 to md0" do
			command 'mdadm --add /dev/md0 /dev/sda2'
		end
		template "/root/grubinstall" do
			source "debuntuinstallgrub.erb"
			owner "root"
			group "root"
			mode '1774'
		end
		execute "install boot after sync /boot.." do
			command "bash /root/grubinstall"
		end
		execute "add sda3 to md1" do
			command 'mdadm --add /dev/md1 /dev/sda3'
		end
		execute "add sda5 to md2" do
			command 'mdadm --add /dev/md2 /dev/sda5'
		end
		raid_part "/dev/sda4" do
			action :mkswap
		end


end

case node["platform"]
	when 'redhat', 'centos', 'amazon', 'scientific', 'oracle'
		if node["platform_version"] == "6"
			template "/etc/fstab" do
				source "fstabafterboot_c6.erb"
				owner "root"
				group "root"
				mode '0644'
			end
		end
end
template "/etc/fstab" do
	source "fstabafterboot.erb"
	owner "root"
	group "root"
	mode '0644'
end


execute "swapon" do
	command "swapon -a"
end

#execute "reboot" do
#	command "shutdown -r now"
#end
reboot 'RAID control reboot' do
	action :request_reboot
	reason 'Need to reboot when the run completes successfully.'
	delay_mins 0
end